unit Maler;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TStreicher = class(TForm)
    Sauron: TButton;
    Uhr: TTimer;
    procedure FormDestroy(Sender: TObject);
    procedure UhrTimer(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
                            Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure SauronClick(Sender: TObject);
  private
    { Private-Deklarationen }
    DCanvas:TCanvas;
    DHandle:HWND; // HandleWindows
    Mitte,Delta:TPoint;
    MaxX,MaxY:Integer;
  public
    { Public-Deklarationen }
  end;

var
  Streicher: TStreicher;

implementation

{$R *.DFM}

 const Radius=30;

 procedure TStreicher.FormCreate(Sender: TObject);
  begin
   Randomize;
  end;

 procedure TStreicher.FormDestroy(Sender: TObject);
  begin
   if ReleaseDc(0,DHandle)<>1 then RaiseLastOSError;
  end;

procedure TStreicher.FormMouseDown(Sender: TObject; Button: TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
  begin
   Uhr.Enabled:=False;
   DCanvas.Ellipse(Mitte.X-Radius,Mitte.Y-Radius,Mitte.X+Radius,Mitte.Y+Radius);
  end;

procedure TStreicher.SauronClick(Sender: TObject);
  begin
   MaxX:=Screen.Width;
   MaxY:=Screen.Height;
   DHandle:=GetDC(0);
   if DHandle<>0 then
    begin
     DCanvas:=TCanvas.Create;
     DCanvas.Handle:=DHandle;
     DCanvas.Brush.Color := clWhite;
     DCanvas.Brush.Style := bsSolid;
     DCanvas.Pen.Mode:=pmXor; // transparent
     Mitte.X:=random(MaxX-50)+25;
     Mitte.Y:=random(MaxY-50)+25;
     Delta.X:=random(Radius)-4;
     Delta.Y:=random(Radius)-4;
     DCanvas.Ellipse(Mitte.X-Radius,Mitte.Y-Radius,Mitte.X+Radius,Mitte.Y+Radius); // zeichnen
     Uhr.Enabled:=True;
    end
   else RaiseLastOSError;
  end;

 procedure TStreicher.UhrTimer(Sender: TObject);
  begin
   DCanvas.Ellipse(Mitte.X-Radius,Mitte.Y-Radius,Mitte.X+Radius,Mitte.Y+Radius); // lschen
   inc(Mitte.X,Delta.X);inc(Mitte.Y,Delta.Y); // neue Position
   if Mitte.X>MaxX-Radius-1 then
    begin
     Mitte.X:=MaxX-Radius-1;
     Delta.X:=-Delta.X;
    end;
   if Mitte.X<Radius+1 then
    begin
     Mitte.X:=Radius+1;
     Delta.X:=-Delta.X;
    end;
   if Mitte.Y>MaxY-Radius-1 then
    begin
     Mitte.Y:=MaxY-Radius-1;
     Delta.Y:=-Delta.Y;
    end;
   if Mitte.Y<Radius+1 then
    begin
     Mitte.Y:=Radius+1;
     Delta.Y:=-Delta.Y;
    end;
   DCanvas.Ellipse(Mitte.X-Radius,Mitte.Y-Radius,Mitte.X+Radius,Mitte.Y+Radius); // neu zeichnen
  end;

end.

